function parse(r,e){if(r instanceof SemVer)return r;if("string"!=typeof r)return null;if(r.length>MAX_LENGTH)return null;var t=e?re[LOOSE]:re[FULL];if(!t.test(r))return null;try{return new SemVer(r,e)}catch(s){return null}}function valid(r,e){var t=parse(r,e);return t?t.version:null}function clean(r,e){var t=parse(r.trim().replace(/^[=v]+/,""),e);return t?t.version:null}function SemVer(r,e){if(r instanceof SemVer){if(r.loose===e)return r;r=r.version}else if("string"!=typeof r)throw new TypeError("Invalid Version: "+r);if(r.length>MAX_LENGTH)throw new TypeError("version is longer than "+MAX_LENGTH+" characters");if(!(this instanceof SemVer))return new SemVer(r,e);debug("SemVer",r,e),this.loose=e;var t=r.trim().match(e?re[LOOSE]:re[FULL]);if(!t)throw new TypeError("Invalid Version: "+r);if(this.raw=r,this.major=+t[1],this.minor=+t[2],this.patch=+t[3],this.major>MAX_SAFE_INTEGER||this.major<0)throw new TypeError("Invalid major version");if(this.minor>MAX_SAFE_INTEGER||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>MAX_SAFE_INTEGER||this.patch<0)throw new TypeError("Invalid patch version");this.prerelease=t[4]?t[4].split(".").map(function(r){if(/^[0-9]+$/.test(r)){var e=+r;if(e>=0&&MAX_SAFE_INTEGER>e)return e}return r}):[],this.build=t[5]?t[5].split("."):[],this.format()}function inc(r,e,t,s){"string"==typeof t&&(s=t,t=void 0);try{return new SemVer(r,t).inc(e,s).version}catch(n){return null}}function diff(r,e){if(eq(r,e))return null;var t=parse(r),s=parse(e);if(t.prerelease.length||s.prerelease.length){for(var n in t)if(("major"===n||"minor"===n||"patch"===n)&&t[n]!==s[n])return"pre"+n;return"prerelease"}for(var n in t)if(("major"===n||"minor"===n||"patch"===n)&&t[n]!==s[n])return n}function compareIdentifiers(r,e){var t=numeric.test(r),s=numeric.test(e);return t&&s&&(r=+r,e=+e),t&&!s?-1:s&&!t?1:e>r?-1:r>e?1:0}function rcompareIdentifiers(r,e){return compareIdentifiers(e,r)}function major(r,e){return new SemVer(r,e).major}function minor(r,e){return new SemVer(r,e).minor}function patch(r,e){return new SemVer(r,e).patch}function compare(r,e,t){return new SemVer(r,t).compare(e)}function compareLoose(r,e){return compare(r,e,!0)}function rcompare(r,e,t){return compare(e,r,t)}function sort(r,e){return r.sort(function(r,t){return exports.compare(r,t,e)})}function rsort(r,e){return r.sort(function(r,t){return exports.rcompare(r,t,e)})}function gt(r,e,t){return compare(r,e,t)>0}function lt(r,e,t){return compare(r,e,t)<0}function eq(r,e,t){return 0===compare(r,e,t)}function neq(r,e,t){return 0!==compare(r,e,t)}function gte(r,e,t){return compare(r,e,t)>=0}function lte(r,e,t){return compare(r,e,t)<=0}function cmp(r,e,t,s){var n;switch(e){case"===":"object"==typeof r&&(r=r.version),"object"==typeof t&&(t=t.version),n=r===t;break;case"!==":"object"==typeof r&&(r=r.version),"object"==typeof t&&(t=t.version),n=r!==t;break;case"":case"=":case"==":n=eq(r,t,s);break;case"!=":n=neq(r,t,s);break;case">":n=gt(r,t,s);break;case">=":n=gte(r,t,s);break;case"<":n=lt(r,t,s);break;case"<=":n=lte(r,t,s);break;default:throw new TypeError("Invalid operator: "+e)}return n}function Comparator(r,e){if(r instanceof Comparator){if(r.loose===e)return r;r=r.value}return this instanceof Comparator?(debug("comparator",r,e),this.loose=e,this.parse(r),this.value=this.semver===ANY?"":this.operator+this.semver.version,void debug("comp",this)):new Comparator(r,e)}function Range(r,e){if(r instanceof Range&&r.loose===e)return r;if(!(this instanceof Range))return new Range(r,e);if(this.loose=e,this.raw=r,this.set=r.split(/\s*\|\|\s*/).map(function(r){return this.parseRange(r.trim())},this).filter(function(r){return r.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+r);this.format()}function toComparators(r,e){return new Range(r,e).set.map(function(r){return r.map(function(r){return r.value}).join(" ").trim().split(" ")})}function parseComparator(r,e){return debug("comp",r),r=replaceCarets(r,e),debug("caret",r),r=replaceTildes(r,e),debug("tildes",r),r=replaceXRanges(r,e),debug("xrange",r),r=replaceStars(r,e),debug("stars",r),r}function isX(r){return!r||"x"===r.toLowerCase()||"*"===r}function replaceTildes(r,e){return r.trim().split(/\s+/).map(function(r){return replaceTilde(r,e)}).join(" ")}function replaceTilde(r,e){var t=e?re[TILDELOOSE]:re[TILDE];return r.replace(t,function(e,t,s,n,o){debug("tilde",r,e,t,s,n,o);var i;return isX(t)?i="":isX(s)?i=">="+t+".0.0 <"+(+t+1)+".0.0":isX(n)?i=">="+t+"."+s+".0 <"+t+"."+(+s+1)+".0":o?(debug("replaceTilde pr",o),"-"!==o.charAt(0)&&(o="-"+o),i=">="+t+"."+s+"."+n+o+" <"+t+"."+(+s+1)+".0"):i=">="+t+"."+s+"."+n+" <"+t+"."+(+s+1)+".0",debug("tilde return",i),i})}function replaceCarets(r,e){return r.trim().split(/\s+/).map(function(r){return replaceCaret(r,e)}).join(" ")}function replaceCaret(r,e){debug("caret",r,e);var t=e?re[CARETLOOSE]:re[CARET];return r.replace(t,function(e,t,s,n,o){debug("caret",r,e,t,s,n,o);var i;return isX(t)?i="":isX(s)?i=">="+t+".0.0 <"+(+t+1)+".0.0":isX(n)?i="0"===t?">="+t+"."+s+".0 <"+t+"."+(+s+1)+".0":">="+t+"."+s+".0 <"+(+t+1)+".0.0":o?(debug("replaceCaret pr",o),"-"!==o.charAt(0)&&(o="-"+o),i="0"===t?"0"===s?">="+t+"."+s+"."+n+o+" <"+t+"."+s+"."+(+n+1):">="+t+"."+s+"."+n+o+" <"+t+"."+(+s+1)+".0":">="+t+"."+s+"."+n+o+" <"+(+t+1)+".0.0"):(debug("no pr"),i="0"===t?"0"===s?">="+t+"."+s+"."+n+" <"+t+"."+s+"."+(+n+1):">="+t+"."+s+"."+n+" <"+t+"."+(+s+1)+".0":">="+t+"."+s+"."+n+" <"+(+t+1)+".0.0"),debug("caret return",i),i})}function replaceXRanges(r,e){return debug("replaceXRanges",r,e),r.split(/\s+/).map(function(r){return replaceXRange(r,e)}).join(" ")}function replaceXRange(r,e){r=r.trim();var t=e?re[XRANGELOOSE]:re[XRANGE];return r.replace(t,function(e,t,s,n,o,i){debug("xRange",r,e,t,s,n,o,i);var a=isX(s),c=a||isX(n),E=c||isX(o),p=E;return"="===t&&p&&(t=""),a?e=">"===t||"<"===t?"<0.0.0":"*":t&&p?(c&&(n=0),E&&(o=0),">"===t?(t=">=",c?(s=+s+1,n=0,o=0):E&&(n=+n+1,o=0)):"<="===t&&(t="<",c?s=+s+1:n=+n+1),e=t+s+"."+n+"."+o):c?e=">="+s+".0.0 <"+(+s+1)+".0.0":E&&(e=">="+s+"."+n+".0 <"+s+"."+(+n+1)+".0"),debug("xRange return",e),e})}function replaceStars(r,e){return debug("replaceStars",r,e),r.trim().replace(re[STAR],"")}function hyphenReplace(r,e,t,s,n,o,i,a,c,E,p,R,u){return e=isX(t)?"":isX(s)?">="+t+".0.0":isX(n)?">="+t+"."+s+".0":">="+e,a=isX(c)?"":isX(E)?"<"+(+c+1)+".0.0":isX(p)?"<"+c+"."+(+E+1)+".0":R?"<="+c+"."+E+"."+p+"-"+R:"<="+a,(e+" "+a).trim()}function testSet(r,e){for(var t=0;t<r.length;t++)if(!r[t].test(e))return!1;if(e.prerelease.length){for(var t=0;t<r.length;t++){if(debug(r[t].semver),r[t].semver===ANY)return!0;if(r[t].semver.prerelease.length>0){var s=r[t].semver;if(s.major===e.major&&s.minor===e.minor&&s.patch===e.patch)return!0}}return!1}return!0}function satisfies(r,e,t){try{e=new Range(e,t)}catch(s){return!1}return e.test(r)}function maxSatisfying(r,e,t){return r.filter(function(r){return satisfies(r,e,t)}).sort(function(r,e){return rcompare(r,e,t)})[0]||null}function validRange(r,e){try{return new Range(r,e).range||"*"}catch(t){return null}}function ltr(r,e,t){return outside(r,e,"<",t)}function gtr(r,e,t){return outside(r,e,">",t)}function outside(r,e,t,s){r=new SemVer(r,s),e=new Range(e,s);var n,o,i,a,c;switch(t){case">":n=gt,o=lte,i=lt,a=">",c=">=";break;case"<":n=lt,o=gte,i=gt,a="<",c="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(satisfies(r,e,s))return!1;for(var E=0;E<e.set.length;++E){var p=e.set[E],R=null,u=null;if(p.forEach(function(r){R=R||r,u=u||r,n(r.semver,R.semver,s)?R=r:i(r.semver,u.semver,s)&&(u=r)}),R.operator===a||R.operator===c)return!1;if((!u.operator||u.operator===a)&&o(r,u.semver))return!1;if(u.operator===c&&i(r,u.semver))return!1}return!0}"object"==typeof module&&module.exports===exports&&(exports=module.exports=SemVer);var debug;debug="object"==typeof process&&process.env&&process.env.NODE_DEBUG&&/\bsemver\b/i.test(process.env.NODE_DEBUG)?function(){var r=Array.prototype.slice.call(arguments,0);r.unshift("SEMVER"),console.log.apply(console,r)}:function(){},exports.SEMVER_SPEC_VERSION="2.0.0";var MAX_LENGTH=256,MAX_SAFE_INTEGER=Number.MAX_SAFE_INTEGER||9007199254740991,re=exports.re=[],src=exports.src=[],R=0,NUMERICIDENTIFIER=R++;src[NUMERICIDENTIFIER]="0|[1-9]\\d*";var NUMERICIDENTIFIERLOOSE=R++;src[NUMERICIDENTIFIERLOOSE]="[0-9]+";var NONNUMERICIDENTIFIER=R++;src[NONNUMERICIDENTIFIER]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var MAINVERSION=R++;src[MAINVERSION]="("+src[NUMERICIDENTIFIER]+")\\.("+src[NUMERICIDENTIFIER]+")\\.("+src[NUMERICIDENTIFIER]+")";var MAINVERSIONLOOSE=R++;src[MAINVERSIONLOOSE]="("+src[NUMERICIDENTIFIERLOOSE]+")\\.("+src[NUMERICIDENTIFIERLOOSE]+")\\.("+src[NUMERICIDENTIFIERLOOSE]+")";var PRERELEASEIDENTIFIER=R++;src[PRERELEASEIDENTIFIER]="(?:"+src[NUMERICIDENTIFIER]+"|"+src[NONNUMERICIDENTIFIER]+")";var PRERELEASEIDENTIFIERLOOSE=R++;src[PRERELEASEIDENTIFIERLOOSE]="(?:"+src[NUMERICIDENTIFIERLOOSE]+"|"+src[NONNUMERICIDENTIFIER]+")";var PRERELEASE=R++;src[PRERELEASE]="(?:-("+src[PRERELEASEIDENTIFIER]+"(?:\\."+src[PRERELEASEIDENTIFIER]+")*))";var PRERELEASELOOSE=R++;src[PRERELEASELOOSE]="(?:-?("+src[PRERELEASEIDENTIFIERLOOSE]+"(?:\\."+src[PRERELEASEIDENTIFIERLOOSE]+")*))";var BUILDIDENTIFIER=R++;src[BUILDIDENTIFIER]="[0-9A-Za-z-]+";var BUILD=R++;src[BUILD]="(?:\\+("+src[BUILDIDENTIFIER]+"(?:\\."+src[BUILDIDENTIFIER]+")*))";var FULL=R++,FULLPLAIN="v?"+src[MAINVERSION]+src[PRERELEASE]+"?"+src[BUILD]+"?";src[FULL]="^"+FULLPLAIN+"$";var LOOSEPLAIN="[v=\\s]*"+src[MAINVERSIONLOOSE]+src[PRERELEASELOOSE]+"?"+src[BUILD]+"?",LOOSE=R++;src[LOOSE]="^"+LOOSEPLAIN+"$";var GTLT=R++;src[GTLT]="((?:<|>)?=?)";var XRANGEIDENTIFIERLOOSE=R++;src[XRANGEIDENTIFIERLOOSE]=src[NUMERICIDENTIFIERLOOSE]+"|x|X|\\*";var XRANGEIDENTIFIER=R++;src[XRANGEIDENTIFIER]=src[NUMERICIDENTIFIER]+"|x|X|\\*";var XRANGEPLAIN=R++;src[XRANGEPLAIN]="[v=\\s]*("+src[XRANGEIDENTIFIER]+")(?:\\.("+src[XRANGEIDENTIFIER]+")(?:\\.("+src[XRANGEIDENTIFIER]+")(?:"+src[PRERELEASE]+")?"+src[BUILD]+"?)?)?";var XRANGEPLAINLOOSE=R++;src[XRANGEPLAINLOOSE]="[v=\\s]*("+src[XRANGEIDENTIFIERLOOSE]+")(?:\\.("+src[XRANGEIDENTIFIERLOOSE]+")(?:\\.("+src[XRANGEIDENTIFIERLOOSE]+")(?:"+src[PRERELEASELOOSE]+")?"+src[BUILD]+"?)?)?";var XRANGE=R++;src[XRANGE]="^"+src[GTLT]+"\\s*"+src[XRANGEPLAIN]+"$";var XRANGELOOSE=R++;src[XRANGELOOSE]="^"+src[GTLT]+"\\s*"+src[XRANGEPLAINLOOSE]+"$";var LONETILDE=R++;src[LONETILDE]="(?:~>?)";var TILDETRIM=R++;src[TILDETRIM]="(\\s*)"+src[LONETILDE]+"\\s+",re[TILDETRIM]=new RegExp(src[TILDETRIM],"g");var tildeTrimReplace="$1~",TILDE=R++;src[TILDE]="^"+src[LONETILDE]+src[XRANGEPLAIN]+"$";var TILDELOOSE=R++;src[TILDELOOSE]="^"+src[LONETILDE]+src[XRANGEPLAINLOOSE]+"$";var LONECARET=R++;src[LONECARET]="(?:\\^)";var CARETTRIM=R++;src[CARETTRIM]="(\\s*)"+src[LONECARET]+"\\s+",re[CARETTRIM]=new RegExp(src[CARETTRIM],"g");var caretTrimReplace="$1^",CARET=R++;src[CARET]="^"+src[LONECARET]+src[XRANGEPLAIN]+"$";var CARETLOOSE=R++;src[CARETLOOSE]="^"+src[LONECARET]+src[XRANGEPLAINLOOSE]+"$";var COMPARATORLOOSE=R++;src[COMPARATORLOOSE]="^"+src[GTLT]+"\\s*("+LOOSEPLAIN+")$|^$";var COMPARATOR=R++;src[COMPARATOR]="^"+src[GTLT]+"\\s*("+FULLPLAIN+")$|^$";var COMPARATORTRIM=R++;src[COMPARATORTRIM]="(\\s*)"+src[GTLT]+"\\s*("+LOOSEPLAIN+"|"+src[XRANGEPLAIN]+")",re[COMPARATORTRIM]=new RegExp(src[COMPARATORTRIM],"g");var comparatorTrimReplace="$1$2$3",HYPHENRANGE=R++;src[HYPHENRANGE]="^\\s*("+src[XRANGEPLAIN]+")\\s+-\\s+("+src[XRANGEPLAIN]+")\\s*$";var HYPHENRANGELOOSE=R++;src[HYPHENRANGELOOSE]="^\\s*("+src[XRANGEPLAINLOOSE]+")\\s+-\\s+("+src[XRANGEPLAINLOOSE]+")\\s*$";var STAR=R++;src[STAR]="(<|>)?=?\\s*\\*";for(var i=0;R>i;i++)debug(i,src[i]),re[i]||(re[i]=new RegExp(src[i]));exports.parse=parse,exports.valid=valid,exports.clean=clean,exports.SemVer=SemVer,SemVer.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},SemVer.prototype.inspect=function(){return'<SemVer "'+this+'">'},SemVer.prototype.toString=function(){return this.version},SemVer.prototype.compare=function(r){return debug("SemVer.compare",this.version,this.loose,r),r instanceof SemVer||(r=new SemVer(r,this.loose)),this.compareMain(r)||this.comparePre(r)},SemVer.prototype.compareMain=function(r){return r instanceof SemVer||(r=new SemVer(r,this.loose)),compareIdentifiers(this.major,r.major)||compareIdentifiers(this.minor,r.minor)||compareIdentifiers(this.patch,r.patch)},SemVer.prototype.comparePre=function(r){if(r instanceof SemVer||(r=new SemVer(r,this.loose)),this.prerelease.length&&!r.prerelease.length)return-1;if(!this.prerelease.length&&r.prerelease.length)return 1;if(!this.prerelease.length&&!r.prerelease.length)return 0;var e=0;do{var t=this.prerelease[e],s=r.prerelease[e];if(debug("prerelease compare",e,t,s),void 0===t&&void 0===s)return 0;if(void 0===s)return 1;if(void 0===t)return-1;if(t!==s)return compareIdentifiers(t,s)}while(++e)},SemVer.prototype.inc=function(r,e){switch(r){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",e);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",e);break;case"prepatch":this.prerelease.length=0,this.inc("patch",e),this.inc("pre",e);break;case"prerelease":0===this.prerelease.length&&this.inc("patch",e),this.inc("pre",e);break;case"major":(0!==this.minor||0!==this.patch||0===this.prerelease.length)&&this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":(0!==this.patch||0===this.prerelease.length)&&this.minor++,this.patch=0,this.prerelease=[];break;case"patch":0===this.prerelease.length&&this.patch++,this.prerelease=[];break;case"pre":if(0===this.prerelease.length)this.prerelease=[0];else{for(var t=this.prerelease.length;--t>=0;)"number"==typeof this.prerelease[t]&&(this.prerelease[t]++,t=-2);-1===t&&this.prerelease.push(0)}e&&(this.prerelease[0]===e?isNaN(this.prerelease[1])&&(this.prerelease=[e,0]):this.prerelease=[e,0]);break;default:throw new Error("invalid increment argument: "+r)}return this.format(),this},exports.inc=inc,exports.diff=diff,exports.compareIdentifiers=compareIdentifiers;var numeric=/^[0-9]+$/;exports.rcompareIdentifiers=rcompareIdentifiers,exports.major=major,exports.minor=minor,exports.patch=patch,exports.compare=compare,exports.compareLoose=compareLoose,exports.rcompare=rcompare,exports.sort=sort,exports.rsort=rsort,exports.gt=gt,exports.lt=lt,exports.eq=eq,exports.neq=neq,exports.gte=gte,exports.lte=lte,exports.cmp=cmp,exports.Comparator=Comparator;var ANY={};Comparator.prototype.parse=function(r){var e=this.loose?re[COMPARATORLOOSE]:re[COMPARATOR],t=r.match(e);if(!t)throw new TypeError("Invalid comparator: "+r);this.operator=t[1],"="===this.operator&&(this.operator=""),this.semver=t[2]?new SemVer(t[2],this.loose):ANY},Comparator.prototype.inspect=function(){return'<SemVer Comparator "'+this+'">'},Comparator.prototype.toString=function(){return this.value},Comparator.prototype.test=function(r){return debug("Comparator.test",r,this.loose),this.semver===ANY?!0:("string"==typeof r&&(r=new SemVer(r,this.loose)),cmp(r,this.operator,this.semver,this.loose))},exports.Range=Range,Range.prototype.inspect=function(){return'<SemVer Range "'+this.range+'">'},Range.prototype.format=function(){return this.range=this.set.map(function(r){return r.join(" ").trim()}).join("||").trim(),this.range},Range.prototype.toString=function(){return this.range},Range.prototype.parseRange=function(r){var e=this.loose;r=r.trim(),debug("range",r,e);var t=e?re[HYPHENRANGELOOSE]:re[HYPHENRANGE];r=r.replace(t,hyphenReplace),debug("hyphen replace",r),r=r.replace(re[COMPARATORTRIM],comparatorTrimReplace),debug("comparator trim",r,re[COMPARATORTRIM]),r=r.replace(re[TILDETRIM],tildeTrimReplace),r=r.replace(re[CARETTRIM],caretTrimReplace),r=r.split(/\s+/).join(" ");var s=e?re[COMPARATORLOOSE]:re[COMPARATOR],n=r.split(" ").map(function(r){return parseComparator(r,e)}).join(" ").split(/\s+/);return this.loose&&(n=n.filter(function(r){return!!r.match(s)})),n=n.map(function(r){return new Comparator(r,e)})},exports.toComparators=toComparators,Range.prototype.test=function(r){if(!r)return!1;"string"==typeof r&&(r=new SemVer(r,this.loose));for(var e=0;e<this.set.length;e++)if(testSet(this.set[e],r))return!0;return!1},exports.satisfies=satisfies,exports.maxSatisfying=maxSatisfying,exports.validRange=validRange,exports.ltr=ltr,exports.gtr=gtr,exports.outside=outside,"function"==typeof define&&define.amd&&define(exports);